package WebFlow.xml;
import WebFlow.*;
import WebFlow.submitJob.*;
import WebFlow.ATD.*;
import org.w3c.dom.*;
import com.ibm.xml.parser.Parser;
import com.ibm.xml.parser.TXDocument;
import java.io.FileInputStream;
import java.io.PrintWriter;
import java.io.File;
import java.util.Vector;
import java.io.*;
import com.ibm.xml.parser.ExternalID;
import com.ibm.xml.parser.DTD; 

/* author: Tomasz Haupt, NPAC at Syracuse University */

public class XmlServerImpl extends BeanContextChildSupport
                           implements WebFlow.xml.XmlServerOperations {

String msg_;
org.omg.CORBA.Object peer;
private Parser parser;
private Document doc;
public String[] piplist;
public String[] poplist;
String[] ipfiles;
String[] opfiles;
String str;
String FileName,Fname;

    public XmlServerImpl(org.omg.CORBA.Object peer, String msg)
	throws WebFlow.NullPointerException {
    
        super(peer); 
        this.peer = peer;
        msg_ = msg;
    }

    public void test() {
        System.out.println("XmlServer is up");
    }

    public boolean instantiateParser(String FileName) {
        boolean status = false;
        try {
            System.out.println("File name is "+FileName);
            File infile = new File(FileName);
            if(infile.exists()) {
              FileInputStream is = new FileInputStream(FileName);
              parser = new Parser(FileName);
              doc = parser.readStream(is);
              if(parser.getNumberOfErrors() > 0) {
               System.out.println("Sorry, the xml document has errors");
               //System.exit(1);
              }
              else {
               status = true;
	      }
	    }
	    else {
               System.out.println("Sorry, file "+FileName+" does not exist");
	    }
	} catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
	}
       return status;
    }

    public void printXML(){
	try {
            ((TXDocument)doc).print(new PrintWriter(System.out));
	} catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
	}
    }

    public void testDOM(){
	try {
            Node root=doc.getDocumentElement();
            System.out.println("document: "+root.getNodeName());
            printAllTags(root); 

	} catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
	}
    }

    public String[] getApplications() {
      String[] result=null;
      try {
        Node root=doc.getDocumentElement(); 
        Vector a =  getAllTags(root,"application");
        int n = a.size();
        result = new String[n];
        for(int i=0; i<n; i++) {
	  result[i]= ((Element)a.elementAt(i)).getAttribute("id");  
	}
      }
      catch (Exception e) {System.out.println(e+" while getAplications");}
      return result;
    }

    private Node[] getApplicationNodes() {
      Node[] result=null;
      try {
        Node root=doc.getDocumentElement(); 
        Vector a =  getAllTags(root,"application");
        int n = a.size();
        result = new Node[n];
        for(int i=0; i<n; i++) {
	  result[i]= (Node)a.elementAt(i);  
	}
      }
      catch (Exception e) {System.out.println(e+" while getAplicationNodes");}
      return result;
    }

    private Node selectApplicationNode(String ApplicationName) {
       Node[] a = getApplicationNodes();
       Node result=null;
       for(int i=0; i<a.length; i++) {
         if(((Element)a[i]).getAttribute("id").equals(ApplicationName)) {
            result = a[i];
            break;
	 }
       }
       return result;
    } 


    public String[] getInstalledHosts(String ApplicationName) {
      String[] hosts=null;
      try {
        Node root=selectApplicationNode(ApplicationName); 
        Vector tags = getAllTags(root,"target");
        int n = tags.size();
        int k = 0;
        for (int i=0; i<n; i++){
	    if(getAttributeValue((Node)tags.elementAt(i),"status","installed")
               .equals("Yes")){ 
                k++;
	    }
	}   
        hosts = new String[k];
        int j = 0; 
        for (int i=0; i<n; i++){
           Node h =(Node)tags.elementAt(i);
           if(getAttributeValue(h,"status","installed").equals("Yes")){
           hosts[j] = ((Element)h).getAttribute("id"); 
           j++;
	   }
	}
       } catch (Exception e) {
        System.out.println(e);
        e.printStackTrace();
      }
      return hosts;
    }   

    public boolean isApplicationInstalled(String Application,String HostName) {
    
        boolean status = false;
	try {
            Node root=selectApplicationNode(Application);
            System.out.println("document: "+root.getNodeName());
            String ApplicationName = ((Element)root).getAttribute("id");
	    System.out.println("Application Name: "+ApplicationName);
        
            boolean found = false;
            Node ch = findTagWithAttribute(root,"target","id",HostName); 
            if(ch != null) {
              if(getAttributeValue(ch,"status","installed") .equals("Yes")){ 
                status=true;
	      }
	    }
	} catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
	}
        
        return status;
    }


 public boolean isApplicationInstallable(String Application) {
       boolean status = false;
         Node root=selectApplicationNode(Application);
         if( ((Element)root).getAttribute("installable").equals("Yes")) {
            status = true;
	 }
       return status;
    }

  public void execCmdLine(String Application, String hostname, String method) {

    System.out.println("execCmdLine called........"); 

    CmdLineEvent clEvent;
    String RSLstring="none";
    String CommandLine="";
    String Host=hostname;
    boolean script=false;

    if(method.equals("Globus")) { 
       Host += "-fork";       
       RSLstring=getRSL(Host);
       if (script) {
         /*find_out_what_data_are_needed
           write RSL string to run the script 
           fire generateScriptEvent 
         */
         System.out.println("scripts are not yet supported");
       }
       else {
       clEvent = new CmdLineEventImpl(getBeanContextChildPeer());
       clEvent.setCmdLine(" ");
       clEvent.setRsl(RSLstring);
       clEvent.setHost(Host);
       fireEvent("submit",clEvent);
       }
    }
    else {
      //       CommandLine=getCommandLine(Application, Host); 
       CommandLine="/usr/bin/ls";
       if (script) {
	 /* find_out_waht_data_are_needed
           write command line to run the script
           fire generateScriptEvent
         */
         System.out.println("scripts are not yet supported");
       }
       else {
       clEvent = new CmdLineEventImpl(getBeanContextChildPeer());
       clEvent.setCmdLine(CommandLine);
       clEvent.setRsl("");
       clEvent.setHost(Host);
       System.out.println("ready to fire: "+CommandLine);
       fireEvent("submit",clEvent);
       System.out.println("event fired!");
       }  
    }
           
  }

  private Node getInstalledNode(String Application, String hostname) {
      Node result=null; 
      result = selectApplicationNode(Application);
      Vector targets = getAllTags(result,"target");
      for(int i=0; i<targets.size();i++) {
      if(((Element)targets.elementAt(i)).getAttribute("id").equals(hostname)) {
            result = (Node)targets.elementAt(i);
            break;
	  }   
      }

      result = findFirstTag(result,"installed");
      return result;
  }

  public String getExec(String Application, String hostname) {
      String result="";
      Node apNode = getInstalledNode(Application,hostname);
      if(apNode==null) {
         System.out.println("getExec: no InstalledNode"); 
         result = "not defined";
      }
      else {
         Node CmdLine = findFirstTag(apNode,"CmdLine");
         if(CmdLine==null) {
           System.out.println("getExec: no CmdLine"); 
           result = "not defined";
	 }
         else {
           String path = getAttributeValue(CmdLine,"Command","path");
           String exec = getAttributeValue(CmdLine,"Command","exec");
           if(path != null) result += path;
           result += exec;
	 }
      }
      return result;
  } 


  public String getRunCommand(String Application, String hostname) {
      Node apNode = getInstalledNode(Application,hostname);
      Node CmdLine = findFirstTag(apNode,"CmdLine");
      String exec = getAttributeValue(CmdLine,"RunCommand","exec");
      String result=exec;
      return result;
  } 


  public String[] getArguments(String Application, String hostname) {
      String[] result = null;
      Node apNode = getInstalledNode(Application,hostname);
      if(apNode != null) {
      Node CmdLine = findFirstTag(apNode,"CmdLine"); 
      if(CmdLine != null) {
      Node Parameters = findFirstTag(CmdLine,"Parameters");
      if( Parameters != null) {
        Vector args = getAllTags(Parameters,"arg");
        if(args.size() > 0) {
          result = new String[args.size()];
	  for(int i=0;i<args.size();i++) {
             result[i]=((Element)args.elementAt(i)).getAttribute("name");
             String m = ((Element)args.elementAt(i)).getAttribute("m");
             String type = ((Element)args.elementAt(i)).getAttribute("type");
             if(m != null) result[i] += " [m"+m+"] [t"+type+"]";  
	  }
	}
      }
      }
      }
    if(result==null) {
       result=new String[1];
       result[0]="null";
    }
    return result;
  }

  public String[] getNameValue(String Application, String hostname) {
      String[] result = null;
      Node apNode = getInstalledNode(Application,hostname);
      Node CmdLine = findFirstTag(apNode,"CmdLine"); 
      Node Parameters = findFirstTag(CmdLine,"Parameters");
      if( Parameters != null) {
        Vector args = getAllTags(Parameters,"NameValue");
        if(args.size() > 0) {
          result = new String[args.size()];
	  for(int i=0;i<args.size();i++) {
             result[i]=((Element)args.elementAt(i)).getAttribute("name");
             result[i]+="="+((Element)args.elementAt(i)).getAttribute("value");
	  }
	}
      }
    if(result==null) {
       result=new String[1];
       result[0]="null";
    }
     return result;
  }

  public String[] getSwitches(String Application, String hostname) {
      String[] result = null;
      Node apNode = getInstalledNode(Application,hostname);
      if(apNode != null) {
      Node CmdLine = findFirstTag(apNode,"CmdLine"); 
      if(CmdLine != null) {
      Node Parameters = findFirstTag(CmdLine,"Parameters");
      if( Parameters != null) {
        Vector args = getAllTags(Parameters,"switch");
        if(args.size() > 0) {
          result = new String[args.size()];
	  for(int i=0;i<args.size();i++) {
             result[i]=((Element)args.elementAt(i)).getAttribute("name");
             String ms=((Element)args.elementAt(i)).getAttribute("ms");
             String s=((Element)args.elementAt(i)).getAttribute("separator");
             String v=((Element)args.elementAt(i)).getAttribute("value");
             String m=((Element)args.elementAt(i)).getAttribute("m");
             String type=((Element)args.elementAt(i)).getAttribute("type");
             if( ms != null) result[i]+=" [ms"+ms+"]";
             if(s != null) {
               result[i]+=" [s"+s+"] [v"+v+"] [t"+type+"]";
	     }
             if( m != null) result[i]+=" [m"+m+"]";
                  
	  }
	}
      }
      }
      }
    if(result==null) {
       result=new String[1];
       result[0]="null";
    }
    return result;
  }



    public String getCommandLine(String Application, String hostname) {
      String rsl="not ready yet";
      boolean status = false;
      String command="";
	try {
            Node root=selectApplicationNode(Application);
            Node ch = findTagWithAttribute(root,"target","id",hostname); 
            if(ch != null) {
              if(getAttributeValue(ch,"status","installed") .equals("Yes")){ 
                status=true;
	      }
              if(status) {
                  // find node <installed>
                  Node ch1 = findFirstTag(ch,"installed"); 
                  // executable or a script to be generated?
                  Node Snode = findFirstTag(ch1,"script");
                  if(Snode == null) {  
                     // retrieve CmdLine
                     Snode = findFirstTag(ch1,"CmdLine");
                     if (Snode == null) {
                       System.out.println("Oops, no CmdLine node!");
                     }
                     else {
                       command = ((Element)Snode).getAttribute("command");
		     }    
		  }
                  else {
		    // there is a script to be generated
                    Node Mnode = findFirstTag(Snode,"module");
                    if(Mnode != null) {  
                     rsl  = "script:";
                     rsl += " name="+((Element)Mnode).getAttribute("name"); 
                     rsl += " idl="+((Element)Mnode).getAttribute("idl"); 
                     rsl += " class="+((Element)Mnode).getAttribute("class");
                    } 
                    else {
                     System.out.println("something fishy... no module tag");
		    } 
		  }  
	      }
              else {
               System.out.println("Sorry, this application is not installed "
               +" on "+hostname);
	      }       
	    }
	} catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
	}
      return command;
    }

    public String getRSL(String hostname) {
      String rsl="not ready yet";
      boolean status = false;
      // find node "installed" and then go over all is childersn tags and
      // grab its attibute
	try {
            Node root=doc.getDocumentElement();
            Node ch = findTagWithAttribute(root,"target","id",hostname); 
            if(ch != null) {
              if(getAttributeValue(ch,"status","installed") .equals("Yes")){ 
                status=true;
	      }
              if(status) {
                  // find node <installed>
                  Node ch1 = findFirstTag(ch,"installed"); 
                  // executable or a script to be generated?
                  Node Snode = findFirstTag(ch1,"script");
                  if(Snode == null) {  
                     // construct RSL
                     rsl="";              
                     for(Node ch2 = ch1.getFirstChild(); ch2!=null;
                                             ch2 = ch2.getNextSibling()) {
	              if(ch2 instanceof Element) {
                         rsl += ch2.getNodeName()+"="; 
                         rsl +=((Element)ch2).getAttribute("file_id")+"; ";
		      }
		     }
		  }
                  else {
		    // there is a script to be generated
                    Node Mnode = findFirstTag(Snode,"module");
                    if(Mnode != null) {  
                     rsl  = "script:";
                     rsl += " name="+((Element)Mnode).getAttribute("name"); 
                     rsl += " idl="+((Element)Mnode).getAttribute("idl"); 
                     rsl += " class="+((Element)Mnode).getAttribute("class");
                    } 
                    else {
                     System.out.println("something fishy... no module tag");
		    } 
		  }  
	      }
              else {
               System.out.println("Sorry, this application is not installed "
               +" on "+hostname);
	      }       
	    }
	} catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
	}
      return rsl;
    } 


    public String getInstallRSL(String hostname) {
      String rsl="not ready yet";
      return rsl;
    } 

    private String getAttributeValue(Node node, String tag, String name) {
        String value="";
          for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
	      if(ch instanceof Element) {
                 if(ch.getNodeName().equals(tag)) {
                    value=((Element)ch).getAttribute(name);
                    break;
		 }
	      }
	  }
      return value;
    }

    private Node findFirstTag(Node node, String tag) {
        Node result=null;
          for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
	      if(ch instanceof Element) {
	     System.out.println(ch.getNodeName());
                 if(ch.getNodeName().equals(tag)) {
                    result=ch;
                    break;
		 }
	      }
	  }
      return result;
    }

    private Vector getAllTags(Node node, String tag) {
        Vector result=new Vector();
          for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
	      if(ch instanceof Element) {
                 if(ch.getNodeName().equals(tag)) {
                    result.addElement(ch);
		 }
	      }
	  }
      return result;
    }


    private Node findTagWithAttribute(Node node, String tag, 
                                      String attr, String value) {
        Node result=null;
        for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
	      if(ch instanceof Element) {
                 if(ch.getNodeName().equals(tag)) {
			if( ((Element)ch).getAttribute(attr).equals(value)){
                           result=ch;
                           break;
			}
		 }
	      }
	  }
      return result;
    }


    private static void printAllTags(Node node){
            for(Node ch = node.getFirstChild(); ch!=null;
                ch = ch.getNextSibling()) {
                if(ch instanceof Element) {
                   System.out.println(ch.getNodeName());
                   NamedNodeMap nnm = ch.getAttributes();
                   for(int i=0;i<nnm.getLength();i++) {
                       Attr attr = (Attr)nnm.item(i);
                       String aname = attr.getNodeName();
                       String avalue = ((Element)ch).getAttribute(aname);
                       System.out.println("-"+aname+"="+avalue);
		   }
                   printAllTags(ch);
		}
	    }
    }

    public boolean createAD (String Application, String hostname) {

        boolean status=true;
	try {
	     Node root=doc.getDocumentElement();
             Vector aTags = getAllTags(root,"application"); 
             int m = aTags.size();
             for (int j=0;j<m;j++) {          
               Node a = (Node)aTags.elementAt(j);
               if( ((Element)a).getAttribute("id").equals(Application)) {
         	  Vector tags = getAllTags(a,"target");
		  int n = tags.size();
         	  for (int i=0; i<n; i++) {
		    Node h = (Node)tags.elementAt(i);
		    if(! ((Element)h).getAttribute("id").equals(hostname)){
  		        a.removeChild(h);
		    }
		  }
               }
               else {
                 root.removeChild(a);
	       }        
	     }
	}
	catch (Exception e){
		System.out.println(e+" while createAD");
	        status=false;
	}
	return status;
    }

    public boolean SaveAsXml (String outputFile) {

        boolean status = true;
	try {
		Node root = doc.getDocumentElement();
		((TXDocument)doc).printWithFormat(new FileWriter(outputFile));
	}
	catch (Exception e){
	  System.out.println(e+" while SaveAsXml");
          status=false;
	}

	return status;
}

    public String[] getIPFiles(String Application, String hname){
	System.out.println(".......getIPFiles");
        Vector vlist = new Vector();
	Vector pilist = new Vector();
	try{
	Node root=selectApplicationNode(Application);
	Vector rtags =getAllTags(root, "target");
	int rn = rtags.size(); 
	for (int i=0; i<rn; i++){
	  Node ch = (Node)rtags.elementAt(i);
	  if( ((Element)ch).getAttribute("id").equals(hname)){
	     NodeList list = ch.getChildNodes();
	     for (int y=0; y<list.getLength(); y++){
		if ((list.item(y).getNodeType()) == 1){
		  if ((list.item(y).getNodeName()).equals("installed")){
		    Vector tags=getAllTags(list.item(y), "input");
		    int n=tags.size();
		    for (int j=0; j<n; j++){
		      Node cch = (Node)tags.elementAt(j);	
              	      Vector ctags = getAllTags(cch, "inFile");
		      Node child = (Node)ctags.elementAt(0);		
		      vlist.addElement(((Element)child).getAttribute("Name"));
		      pilist.addElement(((Element)child).getAttribute("Path"));
		    }
		  }
		}
	     }
	  }
	}
	int j=0;
	ipfiles = new String[2*vlist.size()];
	for (int k=0; k<(2*vlist.size()); k=k+2){
		String s = (String)pilist.get(j);
		ipfiles[k] = s;
		s = (String)vlist.get(j);
		ipfiles[k+1] = s;
		j=j+1;
	}
	}
	catch (Exception e){
		System.out.println(e);
		e.printStackTrace();
	}
	return ipfiles;
}

    public String[] getOPFiles(String Application, String hname){
        
        Vector vlist = new Vector();
	Vector polist = new Vector();
        try{
        Node root=selectApplicationNode(Application);
        Vector rtags =getAllTags(root, "target");
        int rn = rtags.size();
        for (int i=0; i<rn; i++){
                Node ch = (Node)rtags.elementAt(i);
		if( ((Element)ch).getAttribute("id").equals(hname)){
                NodeList list = ch.getChildNodes();
                for (int y=0; y<list.getLength(); y++){
                if ((list.item(y).getNodeType()) == 1){
                if ((list.item(y).getNodeName()).equals("installed")){ 
                Vector tags=getAllTags(list.item(y), "output");
                int n=tags.size();
                for (int j=0; j<n; j++){
                Node cch = (Node)tags.elementAt(j);
                Vector ctags = getAllTags(cch, "outFile");
                Node child = (Node)ctags.elementAt(0);
                vlist.add(((Element)child).getAttribute("Name"));
		polist.add(((Element)child).getAttribute("Path"));   
                        }
                }}}}}
        Object[] ol = vlist.toArray();
	Object[] ppl = polist.toArray();
	int j=0;
        opfiles = new String[2*ol.length];
        for (int k=0; k<2*ol.length; k=k+2){
                String s = (String)ppl[j];
                opfiles[k] = s;
                s = (String)ol[j];
                opfiles[k+1] = s;
                j=j+1;       
        }        
}                  
        catch (Exception e){
                System.out.println(e);
                e.printStackTrace();
        }
        return opfiles;
}                             
             	
   public void addInFile(String Application, String host, String path,
                         String name){
      try{

        boolean found=false; 
        Element inFile = doc.createElement("inFile");
	inFile.setAttribute("Path" , path);
	inFile.setAttribute("Name" , name);

        Node targetNode=getInstalledNode(Application, host);
        Element input=doc.createElement("input");    
        targetNode.appendChild(input);
        input.appendChild(inFile);
      }

      catch (Exception e){
		System.out.println(e+ "while addInFile");
      }
   }
   public void replaceInFile(String Application, String host, String path,
                         String name, String old){
      try{

        boolean found=false; 
        Element inFile = doc.createElement("inFile");
	inFile.setAttribute("Path" , path);
	inFile.setAttribute("Name" , name);

        Node targetNode=getInstalledNode(Application, host);
        Node input = findFirstTag(targetNode,"input");
        if(input==null) {
          input=doc.createElement("input");    
          targetNode.appendChild(input);
	}  
        Node oldInFile=findTagWithAttribute(input,"inFile","Name",old);
        if(oldInFile != null) {
          input.removeChild(oldInFile);
	}
        input.appendChild(inFile);
      }

      catch (Exception e){
		System.out.println(e+ "while addInFile");
      }
   }

   public void addOutFile(String Application, String host, String path,
                          String name){
      try{

        boolean found=false; 
        Element outFile = doc.createElement("outFile");
	outFile.setAttribute("Path" , path);
	outFile.setAttribute("Name" , name);

        Node targetNode=getInstalledNode(Application, host);
        Element output=doc.createElement("output");    
        targetNode.appendChild(output);
  
        output.appendChild(outFile);
      }

      catch (Exception e){
		System.out.println(e+ "while addInFile");
      }
   }
   public void replaceOutFile(String Application, String host, String path,
                          String name, String old){
      try{

        boolean found=false; 
        Element outFile = doc.createElement("outFile");
	outFile.setAttribute("Path" , path);
	outFile.setAttribute("Name" , name);

        Node targetNode=getInstalledNode(Application, host);
        Node output = findFirstTag(targetNode,"output");
        if(output==null) {
          output=doc.createElement("output");    
          targetNode.appendChild(output);
	}  
        Node oldOutFile=findTagWithAttribute(output,"outFile","Name",old);
        if(oldOutFile != null) {
          output.removeChild(oldOutFile);
	}
        output.appendChild(outFile);
      }

      catch (Exception e){
		System.out.println(e+ "while addInFile");
      }
   }

   public void addIPSource(String Application, String host, String f,
                           String[] s){
      try{

        boolean found=false; 
        Element Source = doc.createElement("Source");
	Source.setAttribute("Host" , s[0]);
	Source.setAttribute("Path" , s[1]);
	Source.setAttribute("File",  s[2]);

        Node targetNode=getInstalledNode(Application, host);
        Vector inNodes=getAllTags(targetNode,"input");
        for(int i=0; i<inNodes.size(); i++) {
           Node inFile = findFirstTag((Node)inNodes.elementAt(i),"inFile");   
           if(((Element)inFile).getAttribute("Name").equals(f)) {
               inFile.appendChild(Source);
               found=true; 
               break;
	   }
	} 
        if(!found) {
            Element inputNode = doc.createElement("input");
            targetNode.appendChild(inputNode);
            Element inFileNode = doc.createElement("inFile");
            inFileNode.setAttribute("Name",f);  
            inputNode.appendChild(inFileNode);
            inputNode.appendChild(Source);
	}
      }
      catch (Exception e){
		System.out.println(e+ "while addIPSource");
      }
   }

   public void addOPSource(String Application, String host, String f,
                           String[] s){
      try{

        boolean found=false; 
        Element Source = doc.createElement("Dest");
	Source.setAttribute("Host" , s[0]);
	Source.setAttribute("Path" , s[1]);
	Source.setAttribute("File",  s[2]);

        Node targetNode=getInstalledNode(Application, host);
        Vector outNodes=getAllTags(targetNode,"output");
        for(int i=0; i<outNodes.size(); i++) {
           Node outFile = findFirstTag((Node)outNodes.elementAt(i),"outFile");
           if(((Element)outFile).getAttribute("Name").equals(f)) {
               outFile.appendChild(Source);
               found=true; 
               break;
	   }
	} 
        if(!found) {
            Element outputNode = doc.createElement("output");
            targetNode.appendChild(outputNode);
            Element outFileNode = doc.createElement("outFile");
            outFileNode.setAttribute("Name",f);  
            outputNode.appendChild(outFileNode);
            outputNode.appendChild(Source);
	}
      }
      catch (Exception e){
		System.out.println(e+ "while addOPSource");
      }
   }

   public void addRunCommand(String Application, String host, String f) {

      try{

        boolean found=false; 
        Element RCnode = doc.createElement("RunCommand");
	RCnode.setAttribute("Exec" , f);

        Node targetNode=getInstalledNode(Application, host);
        Node CmdLine = findFirstTag(targetNode,"CmdLine");
        CmdLine.appendChild(RCnode);
      }
      catch (Exception e){
		System.out.println(e+ "while addOPSource");
      }
   }

    public boolean newAAD(String FileName, String dtdFile){

      boolean result=true;

      this.FileName = FileName;
      /* strip out .xml extension and use it as the document name */
      Fname=FileName;
      int idx= Fname.indexOf(".xml");
      String Name=Fname.substring(0, idx);               

      try{
      doc = 
      (Document)Class.forName("com.ibm.xml.parser.TXDocument").newInstance();
      
       ((TXDocument)doc).setVersion("1.0");

       Element root = doc.createElement("ApplicationList"); 
      
       DTD dt=((TXDocument)doc).createDTD
       ("ApplicationList", new ExternalID(dtdFile));

      ((TXDocument)doc).appendChild(dt);
       doc.appendChild(root);

      }
      catch (Exception e) {
        System.out.println(e+ " while newATD");
        result=false;
      }
      return result;
    }
   
    public void addApplication(String application, boolean installable) {
       Node root = doc.getDocumentElement();
       Element item= doc.createElement("application");
       item.setAttribute("id",application);
       if(installable) item.setAttribute("installable","Yes");
       else item.setAttribute("installable","No");
       root.appendChild(item);
    }

    public void addApplicationHost(String Application, String host){
       Node application=selectApplicationNode(Application);
       Element item=doc.createElement("target");
       item.setAttribute("id",host);
       application.appendChild(item);
       Element status=doc.createElement("status");
       status.setAttribute("installed","No");
       item.appendChild(status); 
    }

  public void changeInstalledStatus(String Application, String host,
                                    String newStatus){
       Node application=selectApplicationNode(Application);
       Vector targets = getAllTags(application,"target");  
       Node thisTarget=null; 
       for (int i=0; i<targets.size(); i++) {
	if((((Element)targets.elementAt(i)).getAttribute("id")).equals(host)){
           thisTarget=(Node)targets.elementAt(i);
           break;
	}
       }    
       Node status = findFirstTag(thisTarget,"status");
       ((Element)status).setAttribute("installed",newStatus);
  }

   public void addCommand(String Application, String host, String path,
                          String exec) {
       Node application=selectApplicationNode(Application);
       Vector targets = getAllTags(application,"target");  
       Node thisTarget=null; 
       for (int i=0; i<targets.size(); i++) {
	if((((Element)targets.elementAt(i)).getAttribute("id")).equals(host)){
           thisTarget=(Node)targets.elementAt(i);
           break;
	}
       }    

       Node installedNode = findFirstTag(thisTarget,"installed");
       if(installedNode==null) { 
         Element installed=doc.createElement("installed");
         thisTarget.appendChild(installed);
         Element CmdLine=doc.createElement("CmdLine");
         installed.appendChild(CmdLine);
         Element Command=doc.createElement("Command");
         Command.setAttribute("path",path);
         Command.setAttribute("exec",exec);
         CmdLine.appendChild(Command);
       }
       else {
         Node CmdLineNode = findFirstTag(installedNode,"CmdLine");
         Node CommandNode = findFirstTag(CmdLineNode,"Command");
         CmdLineNode.removeChild(CommandNode);  
         Element Command=doc.createElement("Command");
         Command.setAttribute("path",path);
         Command.setAttribute("exec",exec);
         ((Element)CmdLineNode).appendChild(Command);
       }
   }       

  public void addArgument(String Application, String host, String argument,
                          String type, String m){
       Node installed=getInstalledNode(Application, host);
       Node CmdLine=findFirstTag(installed,"CmdLine");
       Node Parameters=findFirstTag(CmdLine, "Parameters");
       if(Parameters==null) {
        Parameters=doc.createElement("Parameters");
        CmdLine.appendChild(Parameters);
       }
       Node oldArg=findTagWithAttribute(Parameters,"arg","name",argument);
       if(oldArg != null) {
          Parameters.removeChild(oldArg);
       }
       Element arg=doc.createElement("arg");
       arg.setAttribute("name", argument);  
       arg.setAttribute("type", type);  
       arg.setAttribute("m", m);
       Parameters.appendChild(arg);  
  }

  public void addSwitch(String Application, String host, String name,
        String ms, String separator, String value, String type, String m){
       Node installed=getInstalledNode(Application,host);
       Node CmdLine=findFirstTag(installed,"CmdLine");
       Node Parameters=findFirstTag(CmdLine, "Parameters");
       if(Parameters==null) {
        Parameters=doc.createElement("Parameters");
        CmdLine.appendChild(Parameters);
       }
       Node oldSw=findTagWithAttribute(Parameters,"switch","name",name);
       if(oldSw != null) {
          Parameters.removeChild(oldSw);
       }
       Element arg=doc.createElement("switch");
       arg.setAttribute("name", name);  
       arg.setAttribute("ms", ms);  
       arg.setAttribute("separator", separator);  
       arg.setAttribute("value", value);  
       arg.setAttribute("type", type);  
       arg.setAttribute("m", m);
       Parameters.appendChild(arg);  
  }

  public void processJobRequest(WebFlow.xml.jobRequestEvent jrEvent) {
        System.out.println("Event received");
      String xmlFile=jrEvent.getXmlFile();
        System.out.println("Event received: "+xmlFile);
      if(instantiateParser(xmlFile)) {
      } 
  }  

    public void deleteApplication (String Application) {

        boolean status=true;
	try {
	     Node root=doc.getDocumentElement();
             Vector aTags = getAllTags(root,"application"); 
             int m = aTags.size();
             for (int j=0;j<m;j++) {          
               Node a = (Node)aTags.elementAt(j);
               if( ((Element)a).getAttribute("id").equals(Application)) {
                 root.removeChild(a);
                 break; 
	       }
	     }
	}
	catch (Exception e){
		System.out.println(e+" while deleteApplication");
	        status=false;
	}
    }

    public void deleteHost (String Application, String ApplHost) {

        boolean status=true;
	try {
             Node root=selectApplicationNode(Application);               
             Vector hTags = getAllTags(root,"target"); 
             int m = hTags.size();
             for (int j=0;j<m;j++) {          
               Node a = (Node)hTags.elementAt(j);
               if( ((Element)a).getAttribute("id").equals(ApplHost)) {
                 root.removeChild(a);
                 break; 
	       }
	     }
	}
	catch (Exception e){
		System.out.println(e+" while deleteHost");
	        status=false;
	}
    }


    public void deleteArgument(String Application, String host, 
                               String argument){
      try {
       Node installed=getInstalledNode(Application, host);
       Node CmdLine=findFirstTag(installed,"CmdLine");
       Node Parameters=findFirstTag(CmdLine, "Parameters");
       Node thisArgument=findTagWithAttribute(Parameters,"arg",
                                              "name",argument);
       Parameters.removeChild(thisArgument);
      }
      catch (Exception e){
		System.out.println(e+" while deleteArgument");
      }
    }

    public void deleteSwitch(String Application, String host, String sw){
      try {
       System.out.println("delete: "+Application+" "+host+" "+sw);
       Node installed=getInstalledNode(Application, host);
       Node CmdLine=findFirstTag(installed,"CmdLine");
       Node Parameters=findFirstTag(CmdLine, "Parameters");
       System.out.println("find switch: "+sw);
       Node thisSwitch=findTagWithAttribute(Parameters,"switch",
                                              "name",sw);
       Parameters.removeChild(thisSwitch);
      }
      catch (Exception e){
		System.out.println(e+" while deleteSwitch");
      }
    }

    public void deleteInFile(String Application, String host, String name){
      try {
       Node installed=getInstalledNode(Application, host);
       Node input=findFirstTag(installed,"input");
       Node thisInFile=findTagWithAttribute(input,"inFile",
                                              "Name",name);
       input.removeChild(thisInFile);
      }
      catch (Exception e){
		System.out.println(e+" while deleteInFile");
      }
    }

    public void deleteOutFile(String Application, String host, String name){
      try {
       Node installed=getInstalledNode(Application, host);
       Node output=findFirstTag(installed,"output");
       Node thisOutFile=findTagWithAttribute(output,"OutFile",
                                              "Name",name);
       output.removeChild(thisOutFile);
      }
      catch (Exception e){
		System.out.println(e+" while deleteOutFile");
      }
    }


    public void deleteInstalledHost(String Application, String ApplHost){
      deleteHost(Application,ApplHost);  
    }
}


